unit DemoDataExcel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, DataExcel, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Taula: TTable;
    de: TDataExcel;
    DB: TDatabase;
    TaulaCOD_ARTI: TStringField;
    TaulaDESC_ARTI: TStringField;
    TaulaSTOC_ACT: TFloatField;
    TaulaACTIVO: TBooleanField;
    TaulaOTROS: TStringField;
    TaulaVENTAS_ENE: TFloatField;
    TaulaVENTAS_FEB: TFloatField;
    TaulaVENTAS_MAR: TFloatField;
    TaulaPVP: TFloatField;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Panel2: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Edit5: TEdit;
    Label8: TLabel;
    Edit6: TEdit;
    Label9: TLabel;
    ComboBox1: TComboBox;
    Label10: TLabel;
    Edit7: TEdit;
    Label11: TLabel;
    ComboBox2: TComboBox;
    Label12: TLabel;
    Edit8: TEdit;
    CheckBox6: TCheckBox;
    TabSheet2: TTabSheet;
    FDial: TFontDialog;
    Panel3: TPanel;
    Button5: TButton;
    Label19: TLabel;
    CDial: TColorDialog;
    CheckBox7: TCheckBox;
    Button7: TButton;
    Button9: TButton;
    Panel4: TPanel;
    Label20: TLabel;
    Label21: TLabel;
    Edit17: TEdit;
    Label22: TLabel;
    Edit18: TEdit;
    Label23: TLabel;
    Edit19: TEdit;
    Label24: TLabel;
    Edit20: TEdit;
    Label25: TLabel;
    ComboBox3: TComboBox;
    Label26: TLabel;
    Edit21: TEdit;
    Label27: TLabel;
    ComboBox4: TComboBox;
    Label28: TLabel;
    Edit22: TEdit;
    Label29: TLabel;
    Edit23: TEdit;
    CheckBox8: TCheckBox;
    Button8: TButton;
    Panel5: TPanel;
    Label30: TLabel;
    Libros: TComboBox;
    Button12: TButton;
    Label31: TLabel;
    Label32: TLabel;
    Button13: TButton;
    Hojas: TComboBox;
    Button14: TButton;
    Button15: TButton;
    Button2: TButton;
    Button18: TButton;
    Button16: TButton;
    Button3: TButton;
    Button4: TButton;
    Button17: TButton;
    f1: TRadioButton;
    f2: TRadioButton;
    f3: TRadioButton;
    Edit13: TEdit;
    Label17: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Label13: TLabel;
    Label14: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label18: TLabel;
    Edit14: TEdit;
    Button6: TButton;
    Bevel4: TBevel;
    Label33: TLabel;
    Formula: TEdit;
    Button19: TButton;
    Bevel5: TBevel;
    Button10: TButton;
    Button11: TButton;
    od: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure ComboBox2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private declarations }

    Procedure ActivarPanel2;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
   De.AutoAjustarColumnasDatos    := Checkbox1.Checked;
   De.AutoAjustarFormulas         := Checkbox2.Checked;
   De.AutoAjustarFormulasTexto    := Checkbox6.Checked;
   De.CabeceraMostrar             := Checkbox3.Checked;
   De.TituloCombinarCentrar       := Checkbox4.Checked;
   De.VerConstruccion             := Checkbox5.Checked;

   try
      de.FilaInicial := StrToInt(Edit1.Text);
   except
      de.FilaInicial := 0;
   end;
   De.NombreHoja  := Edit2.Text;
   De.Titulo      := Edit3.Text;
   CurrencyString := Edit4.Text;  // Es una variable de sistema que en principio debe tener el valor que este configuardo en el panel de control

   if (Sender as TButton).Tag = 0 then De.TraspasarNuevoLibro
   else De.TraspasarNuevaHoja;
   ActivarPanel2;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   Edit4.Text     := CurrencyString;
   Panel2.Enabled := False;
   F1.Checked     := True;
   ComboBox3.ItemIndex := 0;
   ComboBox4.ItemIndex := 0;
   db.Open;
   Taula.open;
end;

Procedure TForm1.ActivarPanel2;
var
   x: Integer;
begin
   Panel2.Enabled := True;
   Edit5.Text     := IntToStr(De.PrimeraFila);
   Edit6.Text     := IntToStr(De.UltimaFila);

   ComboBox1.Clear;
   for x := 1 to De.Formulas.CuantasFormulas do ComboBox1.Items.Add(De.Formulas.Formula(x));
   Combobox1.ItemIndex := 0;
   Combobox1click(nil);

   ComboBox2.Clear;
   for x := 0 to Taula.FieldCount-1 do
      if Taula.Fields[x].Visible then ComboBox2.Items.Add(Taula.Fields[x].FieldName);
   Combobox2.ItemIndex := 0;
   Combobox2click(nil);
end;


procedure TForm1.ComboBox1Click(Sender: TObject);
begin
   Edit7.Text := De.CasillaFormula(Combobox1.ItemIndex+1);
end;

procedure TForm1.ComboBox2Click(Sender: TObject);
begin
   Edit8.Text := De.RangoCampo(Combobox2.Items[Combobox2.ItemIndex]);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   De.CrearHoja;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
   FDial.Execute;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
   Casilla: String;
   Formato: TAtributosCasilla;
begin
   if F1.Checked  then     Casilla := De.Casilla(StrToInt(Edit9.Text),StrToInt(Edit10.Text))
   else if F2.Checked then Casilla := De.Casilla(Edit11.Text[1],StrToInt(Edit12.Text))
   else Casilla := Edit13.Text;

   De.ValorCasilla(Casilla,Edit14.Text);

   Formato := TAtributosCasilla.Create;

   Formato.Fuente := FDial.Font;
   Formato.ColorFondoActivado := CheckBox7.Checked;
   Formato.ColorFondo := CDial.Color;

   // Se pueden asignar valores a las linias a partir de los propertys
//   Formato.LiniasInterior;
//   Formato.LiniasContorno;
//   Formato.LiniasInteriorGrosor;
//   Formato.LiniasContornoGrosor;
//   Formato.LiniasInteriorColor;
//   Formato.LiniasContornoColor;

   De.AsignarAtributosCasilla(Casilla,formato);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
   CDial.Execute;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
   CDesde,CHasta: String;
begin
   // En este ejemplo esta funcion se debera llamar una vez traspasado el dataset
   // a excel via nuevo libro o nueva hoja.
   
   // miramos si en el ltimo traspaso del tdataset sobre el qual se generar la grafica haba columna
   if Checkbox3.Checked then CDesde := De.Casilla(De.ColumnaCampo('DESC_ARTI'),De.PrimeraFila-1)
   else CDesde := De.Casilla(De.ColumnaCampo('DESC_ARTI'),De.PrimeraFila);

   CHasta := De.Casilla(De.ColumnaCampo('VENTAS_MAR'),De.UltimaFila);

   De.CrearGrafico(Edit21.Text,
                   Cdesde,
                   Chasta,
                   TTipoGrafico(ComboBox3.ItemIndex),
                   TColumna_Fila(ComboBox4.ItemIndex),
                   Edit17.Text,
                   Edit18.Text,
                   Edit19.Text,
                   Edit20.Text,
                   StrToInt(Edit22.Text),
                   StrToInt(Edit23.Text),
                   CheckBox8.Checked);
   ActivarPanel2;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
   Libros.Items.Assign(De.Libros);
   Libros.ItemIndex := 0;
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
   Hojas.Items.Assign(De.Hojas);
   Hojas.ItemIndex := 0;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
   if Libros.Itemindex <> -1 then begin
      De.ActivarLibro(Libros.Items[Libros.itemIndex]);
      Button14Click(Sender);
   end;
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  De.CrearLibro;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
   if Hojas.Itemindex <> -1 then De.ActivarHoja(Hojas.Items[Hojas.itemIndex]);
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
  De.Visible := False;
end;

procedure TForm1.Button19Click(Sender: TObject);
var
   Casilla: String;
   Formato: TAtributosCasilla;
begin
   if F1.Checked  then     Casilla := De.Casilla(StrToInt(Edit9.Text),StrToInt(Edit10.Text))
   else if F2.Checked then Casilla := De.Casilla(Edit11.Text[1],StrToInt(Edit12.Text))
   else Casilla := Edit13.Text;

   De.FormulaCasilla(Casilla,Formula.Text);

   Formato := TAtributosCasilla.Create;

   Formato.Fuente := FDial.Font;
   Formato.ColorFondoActivado := CheckBox7.Checked;
   Formato.ColorFondo := CDial.Color;

   De.AsignarAtributosCasilla(Casilla,formato);
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
   de.Activar;  // lo que hace es crear la instancia de Excel por si no se ha creado anteriormente.
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  De.Visible := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  De.Visible := True;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
   if not od.Execute then Exit;
   De.AbrirLibro(od.FileName);
end;

end.
